<script setup lang="ts">
import { usePartieStore } from '@/stores/partie';
import { computed, onUnmounted, ref } from 'vue';
import AudioProgress from './AudioProgress.vue';
import ParticipantsCard from './ParticipantsCard.vue';
import { useJoueurStore } from '@/stores/joueur';

const emit = defineEmits<{
  buzzer: []
  answer: [text: string]
}>()

const partieStore = usePartieStore()
const joueurStore = useJoueurStore()

const onBuzzer = () => {
  emit('buzzer')
}

const joueurId = computed(() => joueurStore.currentJoueur!!.id)
const disabledBuzzer = computed(() => {
  return partieStore.waitForNextSong ||
    partieStore.audioDuration === null ||
    (partieStore.buzzerActivated !== null && !partieStore.buzzerActivated) ||
    joueurId.value in partieStore.alreadyBuzzed
})
</script>

<template>
  <AudioProgress />
  <div v-if="partieStore.partie"
    class="flex flex-grow gap-4 ml-4 mr-4 mb-4 flex-col items-center sm:flex-row sm:items-stretch">
    <div class="flex-grow flex flex-col justify-center">
      <button class="btn btn-info btn-outline btn-circle h-80 w-80 m-auto text-5xl" @click="onBuzzer"
        :disabled="disabledBuzzer">Buzzer
        !</button>
    </div>

    <ParticipantsCard class="flex-shrink" />
  </div>
</template>
